package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.BGYPSQ;
import com.sa.ibiz.demo.demo.service.BGYPSQService;
import com.sa.ibiz.demo.demo.service.dto.BGYPSQSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/bgypsq")
public class BGYPSQResource
{
	@Autowired
	private BGYPSQService service;


	@PostMapping(value = "/update")
	public ResponseEntity<BGYPSQ> update(@Validated @RequestBody BGYPSQ data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请[update]操作发生错误","BGYPSQ",data.getBgypsqid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<BGYPSQ> remove(@Validated @RequestBody BGYPSQ data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请[remove]操作发生错误","BGYPSQ",data.getBgypsqid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<BGYPSQ> get(@Validated @PathVariable String id){
		BGYPSQ data=new BGYPSQ();
		data.setBgypsqid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("办公用品申请[get]操作发生错误","BGYPSQ",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<BGYPSQ> checkKey(@Validated @RequestBody BGYPSQ data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请[checkKey]操作发生错误","BGYPSQ",data.getBgypsqid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<BGYPSQ> getDraft(@Validated @RequestBody BGYPSQ data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请[getDraft]操作发生错误","BGYPSQ","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<BGYPSQ> create(@Validated @RequestBody BGYPSQ data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请[create]操作发生错误","BGYPSQ",data.getBgypsqid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<BGYPSQ>> searchDefaultPage(@Validated @RequestBody BGYPSQSearchFilter filter){
		Page<BGYPSQ> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<BGYPSQ>> listDefault(@Validated @RequestBody BGYPSQSearchFilter filter){
		List<BGYPSQ> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
